# Assets ## Get info for all assets `client.assets.list(RequestOptionsoptions?): AssetListResponse` **get** `/api/v1/assets` Get info for all assets ### Returns - `AssetListResponse` - `count: number` Total number of objects irrespective of any pagination parameters. - `data: Array` - `asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `id: string` - `group: "native" | "token"` - `"native"` - `"token"` - `group_key: string` - `classification: AssetClassification` The asset's classification metadata. Assets are classfied to provide context on their usage throughout the Neptune API (e.g. regular assets, neptune receipt tokens, LSTs, etc.) Each asset belongs to only a single classification type. This object contains metadata pertaining to the given classification. While some fields may be common among the distinct classifcations, each classification is distinct and subject to independent change. - `Regular` - `kind: "regular"` - `"regular"` - `neptune_receipt_asset: AssetSpec | null` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `NeptuneReceiptToken` - `kind: "neptune_receipt_token"` - `"neptune_receipt_token"` - `origin_asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `LiquidStakingToken` - `kind: "liquid_staking_token"` - `"liquid_staking_token"` - `origin_asset: AssetSpec | null` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `metadata: AssetMetadata` Additional metadata for assets - `decimals_denom: number` Denom exponent, or num. of decimal places that shift between denom/standard amounts (e.g. `18` for `INJ`) - `decimals_display: number` Number of decimals used when displaying amounts of this asset (this is subjective and used for generating text representations) - `name: string` Full name of the asset - `symbol: string` Symbol of the asset, e.g.: `NEPT` `INJ` - `symbol_denom: string` Denom symbol for the asset (e.g. `inj` for `INJ`, `sat` for `BTC`) - `error: unknown` Error data. Guaranteed `null` for successful response. - `status: number` HTTP status. Successful responses are guaranteed to be < `400`. Conversely, error responses are guaranteed to be >= `400`. - `status_text: string` HTTP status text ### Example ```typescript import NeptuneAPIV2 from '@neptunefinance/api-v2'; const client = new NeptuneAPIV2(); const assets = await client.assets.list(); console.log(assets.count); ``` #### Response ```json { "data": [ { "asset": { "id": "native;inj", "group": "native", "group_key": "inj" }, "metadata": { "name": "Injective", "symbol": "INJ", "symbol_denom": "inj", "decimals_denom": 18, "decimals_display": 4 }, "classification": { "kind": "regular", "neptune_receipt_asset": { "id": "token;inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f", "group": "token", "group_key": "inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f" } } } ], "count": 1, "error": null, "status": 200, "status_text": "200 OK" } ``` ## Get all asset prices `client.assets.listPrices(AssetListPricesParamsquery?, RequestOptionsoptions?): AssetListPricesResponse` **get** `/api/v1/assets/prices` Get all asset prices ### Parameters - `query: AssetListPricesParams` - `with_text?: boolean` Include text variation fields ### Returns - `AssetListPricesResponse` - `count: number` Total number of objects irrespective of any pagination parameters. - `data: Array` - `asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `id: string` - `group: "native" | "token"` - `"native"` - `"token"` - `group_key: string` - `classification: AssetClassification` The asset's classification metadata. Assets are classfied to provide context on their usage throughout the Neptune API (e.g. regular assets, neptune receipt tokens, LSTs, etc.) Each asset belongs to only a single classification type. This object contains metadata pertaining to the given classification. While some fields may be common among the distinct classifcations, each classification is distinct and subject to independent change. - `Regular` - `kind: "regular"` - `"regular"` - `neptune_receipt_asset: AssetSpec | null` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `NeptuneReceiptToken` - `kind: "neptune_receipt_token"` - `"neptune_receipt_token"` - `origin_asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `LiquidStakingToken` - `kind: "liquid_staking_token"` - `"liquid_staking_token"` - `origin_asset: AssetSpec | null` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `metadata: AssetMetadata` Additional metadata for assets - `decimals_denom: number` Denom exponent, or num. of decimal places that shift between denom/standard amounts (e.g. `18` for `INJ`) - `decimals_display: number` Number of decimals used when displaying amounts of this asset (this is subjective and used for generating text representations) - `name: string` Full name of the asset - `symbol: string` Symbol of the asset, e.g.: `NEPT` `INJ` - `symbol_denom: string` Denom symbol for the asset (e.g. `inj` for `INJ`, `sat` for `BTC`) - `price: AssetPrice` > **Note**: Prices are sourced from Neptune's Price Oracle - `extra: Extra` - `text: Text | null` Human-readable field variants. Will not be null when query param `with_text` is `true`. - `last_updated_at: string` - `price: string` - `last_updated_at: string` Asset price value, as per Neptune Price Oracle - `price: string` Asset price - `error: unknown` Error data. Guaranteed `null` for successful response. - `status: number` HTTP status. Successful responses are guaranteed to be < `400`. Conversely, error responses are guaranteed to be >= `400`. - `status_text: string` HTTP status text ### Example ```typescript import NeptuneAPIV2 from '@neptunefinance/api-v2'; const client = new NeptuneAPIV2(); const response = await client.assets.listPrices(); console.log(response.count); ``` #### Response ```json { "data": [ { "asset": { "id": "native;inj", "group": "native", "group_key": "inj" }, "metadata": { "name": "Injective", "symbol": "INJ", "symbol_denom": "inj", "decimals_denom": 18, "decimals_display": 4 }, "classification": { "kind": "regular", "neptune_receipt_asset": { "id": "token;inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f", "group": "token", "group_key": "inj1rmzufd7h09sqfrre5dtvu5d09ta7c0t4jzkr2f" } }, "price": { "price": "13.38184253", "last_updated_at": "2026-04-09T23:39:59.131618736Z", "extra": { "text": { "price": "$13.38", "last_updated_at": "2026-04-09 11:39:59 PM +00:00" } } } } ], "count": 1, "error": null, "status": 200, "status_text": "200 OK" } ``` ## Get historical prices for assets `client.assets.getPriceHistory(AssetGetPriceHistoryParamsquery, RequestOptionsoptions?): AssetGetPriceHistoryResponse` **get** `/api/v1/assets/price-history` Get historical prices for assets ### Parameters - `query: AssetGetPriceHistoryParams` - `end: number` End timestamp for interval range (inclusive) Must be provided as unix timestamp (in seconds) - `period: IntervalUnit` Interval period Values: - `h`: Hourly - `d`: Daily (accounts for offsets introduced by DST) - `w`: Weekly (provided for convenience, equivalent to 7d) - `m`: Monthly (accounts for varying \# of days per month) - `y`: Yearly (accounts for varying \# of days per year) E.g. for interval buckets of 2h `interval=2&period=h` - `"h"` - `"d"` - `"w"` - `"m"` - `"y"` - `start: number` Start timestamp for interval range (inclusive) Must be provided as unix timestamp (in seconds) - `asset_ids?: string | null` Optional comma-separated list of asset IDs to filter for. If excluded, values will be returned for all assets. - `interval?: number` Interval value E.g. for interval buckets of 2h: `interval=2&period=h` - `limit?: number` Maximum number of time buckets/intervals to return. For responses with multiple series, this limit is applied to each series individually rather than accumulating across series. This is a limit of returned *interval sections*, it is **not** a limit of returned *points*. In other words, `limit=200` will provide 200 time points for a single series. For multi-series responses, each series will also see the exact same set of 200 time points. - `offset?: number` Time series bucket offset ### Returns - `AssetGetPriceHistoryResponse` - `data: AssetPriceHistory` Historical prices for assets - `pagination: Pagination` Values used for paginating the time series data - `interval_count: number` The total number of intervals/buckets for the provided interval parameters (size, period, start, end) - `next_offset: number | null` The offset a client should use to fetch the next page of intervals (so long as limit remains unchanged) - `range: Range` Provides values for the requested range in it's entire width, regardless of page/limit. - `end: string` - `interval: Interval` Interval period & size - `unit: IntervalUnit` - `"h"` - `"d"` - `"w"` - `"m"` - `"y"` - `value: number` - `start: string` - `series: Array` - `asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `id: string` - `group: "native" | "token"` - `"native"` - `"token"` - `group_key: string` - `points: Array` - `t: string` - `v: string | null` - `error: unknown` Error data. Guaranteed `null` for successful response. - `status: number` HTTP status. Successful responses are guaranteed to be < `400`. Conversely, error responses are guaranteed to be >= `400`. - `status_text: string` HTTP status text ### Example ```typescript import NeptuneAPIV2 from '@neptunefinance/api-v2'; const client = new NeptuneAPIV2(); const response = await client.assets.getPriceHistory({ end: 0, period: 'h', start: 0, }); console.log(response.data); ``` #### Response ```json { "data": { "range": { "start": 1775173209, "end": 1775778009, "interval": { "value": 1, "unit": "d" } }, "series": [ { "asset": { "id": "native;inj", "group": "native", "group_key": "inj" }, "points": [ { "t": 1775173209, "v": "0.1" }, { "t": 1775259609, "v": "0.1" }, { "t": 1775346009, "v": "0.1" }, { "t": 1775432409, "v": "0.1" }, { "t": 1775518809, "v": "0.1" }, { "t": 1775605209, "v": "0.1" }, { "t": 1775691609, "v": "0.1" }, { "t": 1775778009, "v": "0.1" } ] } ], "pagination": { "next_offset": 200, "interval_count": 221 } }, "error": null, "status": 200, "status_text": "200 OK" } ``` ## Domain Types ### Asset Classification - `AssetClassification = Regular | NeptuneReceiptToken | LiquidStakingToken` The asset's classification metadata. Assets are classfied to provide context on their usage throughout the Neptune API (e.g. regular assets, neptune receipt tokens, LSTs, etc.) Each asset belongs to only a single classification type. This object contains metadata pertaining to the given classification. While some fields may be common among the distinct classifcations, each classification is distinct and subject to independent change. - `Regular` - `kind: "regular"` - `"regular"` - `neptune_receipt_asset: AssetSpec | null` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `id: string` - `group: "native" | "token"` - `"native"` - `"token"` - `group_key: string` - `NeptuneReceiptToken` - `kind: "neptune_receipt_token"` - `"neptune_receipt_token"` - `origin_asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `LiquidStakingToken` - `kind: "liquid_staking_token"` - `"liquid_staking_token"` - `origin_asset: AssetSpec | null` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) ### Asset Info - `AssetInfo` Asset identifiers with associated metadata - `asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `id: string` - `group: "native" | "token"` - `"native"` - `"token"` - `group_key: string` - `classification: AssetClassification` The asset's classification metadata. Assets are classfied to provide context on their usage throughout the Neptune API (e.g. regular assets, neptune receipt tokens, LSTs, etc.) Each asset belongs to only a single classification type. This object contains metadata pertaining to the given classification. While some fields may be common among the distinct classifcations, each classification is distinct and subject to independent change. - `Regular` - `kind: "regular"` - `"regular"` - `neptune_receipt_asset: AssetSpec | null` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `NeptuneReceiptToken` - `kind: "neptune_receipt_token"` - `"neptune_receipt_token"` - `origin_asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `LiquidStakingToken` - `kind: "liquid_staking_token"` - `"liquid_staking_token"` - `origin_asset: AssetSpec | null` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `metadata: AssetMetadata` Additional metadata for assets - `decimals_denom: number` Denom exponent, or num. of decimal places that shift between denom/standard amounts (e.g. `18` for `INJ`) - `decimals_display: number` Number of decimals used when displaying amounts of this asset (this is subjective and used for generating text representations) - `name: string` Full name of the asset - `symbol: string` Symbol of the asset, e.g.: `NEPT` `INJ` - `symbol_denom: string` Denom symbol for the asset (e.g. `inj` for `INJ`, `sat` for `BTC`) ### Asset Metadata - `AssetMetadata` Additional metadata for assets - `decimals_denom: number` Denom exponent, or num. of decimal places that shift between denom/standard amounts (e.g. `18` for `INJ`) - `decimals_display: number` Number of decimals used when displaying amounts of this asset (this is subjective and used for generating text representations) - `name: string` Full name of the asset - `symbol: string` Symbol of the asset, e.g.: `NEPT` `INJ` - `symbol_denom: string` Denom symbol for the asset (e.g. `inj` for `INJ`, `sat` for `BTC`) ### Asset Price - `AssetPrice` > **Note**: Prices are sourced from Neptune's Price Oracle - `extra: Extra` - `text: Text | null` Human-readable field variants. Will not be null when query param `with_text` is `true`. - `last_updated_at: string` - `price: string` - `last_updated_at: string` Asset price value, as per Neptune Price Oracle - `price: string` Asset price ### Asset Price History - `AssetPriceHistory` Historical prices for assets - `pagination: Pagination` Values used for paginating the time series data - `interval_count: number` The total number of intervals/buckets for the provided interval parameters (size, period, start, end) - `next_offset: number | null` The offset a client should use to fetch the next page of intervals (so long as limit remains unchanged) - `range: Range` Provides values for the requested range in it's entire width, regardless of page/limit. - `end: string` - `interval: Interval` Interval period & size - `unit: IntervalUnit` - `"h"` - `"d"` - `"w"` - `"m"` - `"y"` - `value: number` - `start: string` - `series: Array` - `asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `id: string` - `group: "native" | "token"` - `"native"` - `"token"` - `group_key: string` - `points: Array` - `t: string` - `v: string | null` ### Asset Rate History - `AssetRateHistory` Historical rates for assets - `pagination: Pagination` Values used for paginating the time series data - `interval_count: number` The total number of intervals/buckets for the provided interval parameters (size, period, start, end) - `next_offset: number | null` The offset a client should use to fetch the next page of intervals (so long as limit remains unchanged) - `range: Range` Provides values for the requested range in it's entire width, regardless of page/limit. - `end: string` - `interval: Interval` Interval period & size - `unit: IntervalUnit` - `"h"` - `"d"` - `"w"` - `"m"` - `"y"` - `value: number` - `start: string` - `series: Array` - `asset: AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `id: string` - `group: "native" | "token"` - `"native"` - `"token"` - `group_key: string` - `points: Array` - `t: string` - `v: string | null` ### Asset Spec - `AssetSpec` Provides a unique identifier for an asset for use throughout the Neptune API. IDs are unique across asset domains (contract tokens, native denoms, etc) - `id: string` - `group: "native" | "token"` - `"native"` - `"token"` - `group_key: string`